;*************************************************************************
; Copyright (c) 2002 The University of Chicago, as Operator of Argonne
; National Laboratory.
; Copyright (c) 2002 The Regents of the University of California, as
; Operator of Los Alamos National Laboratory.
; This file is distributed subject to a Software License Agreement found
; in the file LICENSE that is included with this distribution. 
;*************************************************************************
pro row_ascii
	catch, error_status
	if(error_status NE 0) then begin
		print, 'ERROR_MESSAGE:',!ERR_STRING
		if (OBJ_VALID(a)) then OBJ_DESTROY, a
		return
	endif

i=0l
a=obj_new('sdds_table','row_ascii.sdds', /NEW)
if (NOT OBJ_VALID(a)) then MESSAGE, 'object-a- not created!'

a->setcolumndefinition, {NAME:'double'}
a->setcolumndefinition, {NAME:'float',TYPE:'FLOAT'}
a->setcolumndefinition, {NAME:'long',TYPE:'LONG',DESCRIPTION:'a long'}
a->setcolumndefinition, {NAME:'short',TYPE:'SHORT',UNITS:'Volts'}
a->setcolumndefinition, {NAME:'string1',TYPE:'STRING',DESCRIPTION:'a date'}
a->setcolumndefinition, {NAME:'byte',TYPE:'BYTE'}

a->startTable, 10

d=[1.1D,2.2D,3.3D,4.4D,5.5D]
f=[1.1,2.2,3.3,4.4,5.5]
l=[1l,2l,3l,4l,5l]
s=[1,2,3,4,5]
strings=['1','2','3','4','5']
b=[1B,2B,3B,4B,5B]

for i=0, n_elements(d)-1 do begin
	a->setrow, 'double',d[i], i
	a->setrow, 'float', f[i], i
	a->setrow, 'long',  l[i], i
	a->setrow, 'short', s[i], i
	a->setrow, 'byte',  b[i], i
	a->setrow, 'string1', strings[i], i
end


a->writeTable

d1=d+1.1D
f1=f+1.1
l1=l+1l
s1=s+1
b1=b+1
strings1=['2','3','4','5','6']

for i=0, n_elements(d)-1 do begin
	a->setrow, 'double',d1[i], i
	a->setrow, 'float', f1[i], i
	a->setrow, 'long',  l1[i], i
	a->setrow, 'short', s1[i], i
	a->setrow, 'byte',  b1[i], i
	a->setrow, 'string1', strings1[i], i
end

a->writeTable

obj_destroy, a

a=obj_new('sdds_table','row_ascii.sdds')
if (NOT OBJ_VALID(a)) then MESSAGE, 'object-a- not created!'

r=a->readTable()

rd=a->getColumn('double')
rf=a->getColumn('float')
rl=a->getColumn('long')
rs=a->getColumn('short')
rst=a->getColumn('string1')
rb=a->getColumn('byte')

r=a->readTable()

rd1=a->getColumn('double')
rf1=a->getColumn('float')
rl1=a->getColumn('long')
rs1=a->getColumn('short')
rst1=a->getColumn('string1')
rb1=a->getColumn('byte')

i=0l
for i=0, n_elements(d)-1  do begin
	print, 'INDEX=',i
	if d[i] NE  rd[i] then print,'DOUBLE ',d[i],'',rd[i]
	if d1[i] NE  rd1[i] then print, 'DOUBLE1 ',d1[i], ' ',rd1[i]
	if f[i] NE  rf[i] then print,'FLOAT ',f[i],'',rf[i]
	if f1[i] NE  rf1[i] then  print,'FLOAT1 ',f1[i],'',rf1[i]
	if l[i] NE  rl[i] then  print,'LONG ',l[i],'',rl[i]
	if l1[i] NE  rl1[i] then  print,'LONG1 ',l1[i],'',rl1[i]
	if s[i] NE  rs[i] then print,'SHORT ',s[i],'',rs[i]
	if s1[i] NE  rs1[i] then  print,'SHORT1 ',s1[i],'',rs1[i]
	if b[i] NE  rb[i] then print,'BYTE ',b[i],'',rb[i]
	if b1[i] NE  rb1[i] then print,'BYTE1 ',b1[i],'',rb1[i]
	if strings[i] NE  rst[i] then  print,'STRING ',strings[i],'',rst[i]
	if strings1[i] NE  rst1[i] then print,'STRING1 ',strings1[i],'',rst1[i]
end
return
end
